/* This is a template file generated by command */
/* orbit-idl-2 --skeleton-impl ulci_as.idl */
/* User must edit this file, inserting servant  */
/* specific code between markers. */

#include "ulci_as.h"

/*** App-specific servant structures ***/

#if !defined(_typedef_impl_POA_ulci_statistics_)
#define _typedef_impl_POA_ulci_statistics_ 1
typedef struct {
POA_ulci_statistics servant;
PortableServer_POA poa;
CORBA_string attr_start_time;
CORBA_unsigned_long attr_dy_adr_asg_cnt;
CORBA_string attr_dy_adr_asg_last;
CORBA_unsigned_long attr_st_adr_req_cnt;
CORBA_string attr_st_adr_reg_last;
   /* ------ add private attributes here ------ */
ul_asd_context_t *ul_cont;
   /* ------ ---------- end ------------ ------ */
} impl_POA_ulci_statistics;
#endif

#if !defined(_typedef_impl_POA_ulci_settings_)
#define _typedef_impl_POA_ulci_settings_ 1
typedef struct {
POA_ulci_settings servant;
PortableServer_POA poa;
CORBA_unsigned_short attr_status_period;
CORBA_unsigned_short attr_first_dy_adr;
CORBA_unsigned_short attr_cycle_start;
   /* ------ add private attributes here ------ */
ul_asd_context_t *ul_cont;
   /* ------ ---------- end ------------ ------ */
} impl_POA_ulci_settings;
#endif


/*** Implementation stub prototypes ***/

#if !defined(_decl_impl_ulci_statistics__destroy_)
#define _decl_impl_ulci_statistics__destroy_ 1
static void impl_ulci_statistics__destroy(impl_POA_ulci_statistics *servant,
CORBA_Environment *ev);
#endif

#if !defined(_decl_impl_ulci_statistics__get_start_time_)
#define _decl_impl_ulci_statistics__get_start_time_ 1
static CORBA_string
impl_ulci_statistics__get_start_time(impl_POA_ulci_statistics *servant,
CORBA_Environment *ev);
#endif

#if !defined(_decl_impl_ulci_statistics__get_dy_adr_asg_cnt_)
#define _decl_impl_ulci_statistics__get_dy_adr_asg_cnt_ 1
static CORBA_unsigned_long
impl_ulci_statistics__get_dy_adr_asg_cnt(impl_POA_ulci_statistics *servant,
CORBA_Environment *ev);
#endif

#if !defined(_decl_impl_ulci_statistics__get_dy_adr_asg_last_)
#define _decl_impl_ulci_statistics__get_dy_adr_asg_last_ 1
static CORBA_string
impl_ulci_statistics__get_dy_adr_asg_last(impl_POA_ulci_statistics *servant,
CORBA_Environment *ev);
#endif

#if !defined(_decl_impl_ulci_statistics__get_st_adr_req_cnt_)
#define _decl_impl_ulci_statistics__get_st_adr_req_cnt_ 1
static CORBA_unsigned_long
impl_ulci_statistics__get_st_adr_req_cnt(impl_POA_ulci_statistics *servant,
CORBA_Environment *ev);
#endif

#if !defined(_decl_impl_ulci_statistics__get_st_adr_reg_last_)
#define _decl_impl_ulci_statistics__get_st_adr_reg_last_ 1
static CORBA_string
impl_ulci_statistics__get_st_adr_reg_last(impl_POA_ulci_statistics *servant,
CORBA_Environment *ev);
#endif

#if !defined(_decl_impl_ulci_settings__destroy_)
#define _decl_impl_ulci_settings__destroy_ 1
static void impl_ulci_settings__destroy(impl_POA_ulci_settings *servant,
CORBA_Environment *ev);
#endif

#if !defined(_decl_impl_ulci_settings__get_status_period_)
#define _decl_impl_ulci_settings__get_status_period_ 1
static CORBA_unsigned_short
impl_ulci_settings__get_status_period(impl_POA_ulci_settings *servant,
CORBA_Environment *ev);
#endif

#if !defined(_decl_impl_ulci_settings__set_status_period_)
#define _decl_impl_ulci_settings__set_status_period_ 1
static void
impl_ulci_settings__set_status_period(impl_POA_ulci_settings *servant,
const CORBA_unsigned_short value,
CORBA_Environment *ev);
#endif

#if !defined(_decl_impl_ulci_settings__get_first_dy_adr_)
#define _decl_impl_ulci_settings__get_first_dy_adr_ 1
static CORBA_unsigned_short
impl_ulci_settings__get_first_dy_adr(impl_POA_ulci_settings *servant,
CORBA_Environment *ev);
#endif

#if !defined(_decl_impl_ulci_settings__set_first_dy_adr_)
#define _decl_impl_ulci_settings__set_first_dy_adr_ 1
static void
impl_ulci_settings__set_first_dy_adr(impl_POA_ulci_settings *servant,
const CORBA_unsigned_short value,
CORBA_Environment *ev);
#endif

#if !defined(_decl_impl_ulci_settings__get_cycle_start_)
#define _decl_impl_ulci_settings__get_cycle_start_ 1
static CORBA_unsigned_short
impl_ulci_settings__get_cycle_start(impl_POA_ulci_settings *servant,
CORBA_Environment *ev);
#endif

#if !defined(_decl_impl_ulci_settings__set_cycle_start_)
#define _decl_impl_ulci_settings__set_cycle_start_ 1
static void
impl_ulci_settings__set_cycle_start(impl_POA_ulci_settings *servant,
const CORBA_unsigned_short value,
CORBA_Environment *ev);
#endif

#if !defined(_decl_impl_ulci_settings_add_static_unit_)
#define _decl_impl_ulci_settings_add_static_unit_ 1
static void
impl_ulci_settings_add_static_unit(impl_POA_ulci_settings *servant,
const CORBA_unsigned_short adr,
const CORBA_unsigned_short sn,
CORBA_Environment *ev);
#endif

#if !defined(_decl_impl_ulci_settings_remove_static_unit_)
#define _decl_impl_ulci_settings_remove_static_unit_ 1
static void
impl_ulci_settings_remove_static_unit(impl_POA_ulci_settings *servant,
const CORBA_unsigned_short sn,
CORBA_Environment *ev);
#endif

#if !defined(_decl_impl_ulci_settings_get_units_)
#define _decl_impl_ulci_settings_get_units_ 1
static ulci_units_t*
impl_ulci_settings_get_units(impl_POA_ulci_settings *servant,
CORBA_Environment *ev);
#endif

#if !defined(_decl_impl_ulci_settings_save_)
#define _decl_impl_ulci_settings_save_ 1
static void
impl_ulci_settings_save(impl_POA_ulci_settings *servant,
CORBA_Environment *ev);
#endif


/*** epv structures ***/

#if !defined(_impl_ulci_statistics_base_epv_)
#define _impl_ulci_statistics_base_epv_ 1
static PortableServer_ServantBase__epv impl_ulci_statistics_base_epv = {
NULL,             /* _private data */
(gpointer) & impl_ulci_statistics__destroy, /* finalize routine */
NULL,             /* default_POA routine */
};
#endif

#if !defined(_impl_ulci_statistics_epv_)
#define _impl_ulci_statistics_epv_ 1
static POA_ulci_statistics__epv impl_ulci_statistics_epv = {
NULL, /* _private */
(gpointer)&impl_ulci_statistics__get_start_time,
(gpointer)&impl_ulci_statistics__get_dy_adr_asg_cnt,
(gpointer)&impl_ulci_statistics__get_dy_adr_asg_last,
(gpointer)&impl_ulci_statistics__get_st_adr_req_cnt,
(gpointer)&impl_ulci_statistics__get_st_adr_reg_last,
};
#endif

#if !defined(_impl_ulci_settings_base_epv_)
#define _impl_ulci_settings_base_epv_ 1
static PortableServer_ServantBase__epv impl_ulci_settings_base_epv = {
NULL,             /* _private data */
(gpointer) & impl_ulci_settings__destroy, /* finalize routine */
NULL,             /* default_POA routine */
};
#endif

#if !defined(_impl_ulci_settings_epv_)
#define _impl_ulci_settings_epv_ 1
static POA_ulci_settings__epv impl_ulci_settings_epv = {
NULL, /* _private */
(gpointer)&impl_ulci_settings__get_status_period,
(gpointer)&impl_ulci_settings__set_status_period,
(gpointer)&impl_ulci_settings__get_first_dy_adr,
(gpointer)&impl_ulci_settings__set_first_dy_adr,
(gpointer)&impl_ulci_settings__get_cycle_start,
(gpointer)&impl_ulci_settings__set_cycle_start,
(gpointer)&impl_ulci_settings_add_static_unit,
(gpointer)&impl_ulci_settings_remove_static_unit,
(gpointer)&impl_ulci_settings_get_units,
(gpointer)&impl_ulci_settings_save,
};
#endif


/*** vepv structures ***/

#if !defined(_impl_ulci_statistics_vepv_)
#define _impl_ulci_statistics_vepv_ 1
static POA_ulci_statistics__vepv impl_ulci_statistics_vepv = {
&impl_ulci_statistics_base_epv,
&impl_ulci_statistics_epv,
};
#endif

#if !defined(_impl_ulci_settings_vepv_)
#define _impl_ulci_settings_vepv_ 1
static POA_ulci_settings__vepv impl_ulci_settings_vepv = {
&impl_ulci_settings_base_epv,
&impl_ulci_settings_epv,
};
#endif


/*** Stub implementations ***/

#if !defined(_impl_ulci_statistics__create_)
#define _impl_ulci_statistics__create_ 1
static ulci_statistics impl_ulci_statistics__create(PortableServer_POA poa, CORBA_Environment *ev, ul_asd_context_t *ul_cont)
{
ulci_statistics retval;
impl_POA_ulci_statistics *newservant;
PortableServer_ObjectId *objid;

newservant = g_new0(impl_POA_ulci_statistics, 1);
newservant->servant.vepv = &impl_ulci_statistics_vepv;
newservant->poa = (PortableServer_POA) CORBA_Object_duplicate((CORBA_Object)poa, ev);
POA_ulci_statistics__init((PortableServer_Servant)newservant, ev);
   /* Before servant is going to be activated all
    * private attributes must be initialized.  */
newservant->ul_cont=ul_cont;
   /* ------ init private attributes here ------ */
   /* ------ ---------- end ------------- ------ */

objid = PortableServer_POA_activate_object(poa, newservant, ev);
CORBA_free(objid);
retval = PortableServer_POA_servant_to_reference(poa, newservant, ev);

return retval;
}
#endif

#if !defined(_impl_ulci_statistics__destroy_)
#define _impl_ulci_statistics__destroy_ 1
static void
impl_ulci_statistics__destroy(impl_POA_ulci_statistics *servant, CORBA_Environment *ev)
{
    CORBA_Object_release ((CORBA_Object) servant->poa, ev);

    /* No further remote method calls are delegated to 
    * servant and you may free your private attributes. */
   /* ------ free private attributes here ------ */
   /* ------ ---------- end ------------- ------ */

POA_ulci_statistics__fini((PortableServer_Servant)servant, ev);

g_free (servant);
}
#endif

#if !defined(_impl_ulci_statistics__get_start_time_)
#define _impl_ulci_statistics__get_start_time_ 1
static CORBA_string
impl_ulci_statistics__get_start_time(impl_POA_ulci_statistics *servant,
CORBA_Environment *ev)
{
CORBA_string retval;
 /* ------   insert method code here   ------ */
   struct tm *t;
   char buff[64];
   
   g_mutex_lock(servant->ul_cont->mutex);
   t=localtime(&servant->ul_cont->ul_net->statistics->start_time);
   strftime(buff,sizeof(buff),"%d.%m.%Y %H:%M:%S",t);
   retval=CORBA_string_dup(buff);   
   g_mutex_unlock(servant->ul_cont->mutex);
 /* ------ ---------- end ------------ ------ */

return retval;
}
#endif

#if !defined(_impl_ulci_statistics__get_dy_adr_asg_cnt_)
#define _impl_ulci_statistics__get_dy_adr_asg_cnt_ 1
static CORBA_unsigned_long
impl_ulci_statistics__get_dy_adr_asg_cnt(impl_POA_ulci_statistics *servant,
CORBA_Environment *ev)
{
CORBA_unsigned_long retval;
 /* ------   insert method code here   ------ */
   g_mutex_lock(servant->ul_cont->mutex);
   retval=servant->ul_cont->ul_net->statistics->dy_adr_asg_cnt;
   g_mutex_unlock(servant->ul_cont->mutex);
 /* ------ ---------- end ------------ ------ */

return retval;
}
#endif

#if !defined(_impl_ulci_statistics__get_dy_adr_asg_last_)
#define _impl_ulci_statistics__get_dy_adr_asg_last_ 1
static CORBA_string
impl_ulci_statistics__get_dy_adr_asg_last(impl_POA_ulci_statistics *servant,
CORBA_Environment *ev)
{
CORBA_string retval;
 /* ------   insert method code here   ------ */
   struct tm *t;
   char buff[64];
   
   g_mutex_lock(servant->ul_cont->mutex);
   t=localtime(&servant->ul_cont->ul_net->statistics->dy_adr_asg_last);
   strftime(buff,sizeof(buff),"%d.%m.%Y %H:%M:%S",t);
   retval=CORBA_string_dup(buff);   
   g_mutex_unlock(servant->ul_cont->mutex);
 /* ------ ---------- end ------------ ------ */

return retval;
}
#endif

#if !defined(_impl_ulci_statistics__get_st_adr_req_cnt_)
#define _impl_ulci_statistics__get_st_adr_req_cnt_ 1
static CORBA_unsigned_long
impl_ulci_statistics__get_st_adr_req_cnt(impl_POA_ulci_statistics *servant,
CORBA_Environment *ev)
{
CORBA_unsigned_long retval;
 /* ------   insert method code here   ------ */
   g_mutex_lock(servant->ul_cont->mutex);
   retval=servant->ul_cont->ul_net->statistics->st_adr_req_cnt;
   g_mutex_unlock(servant->ul_cont->mutex);
 /* ------ ---------- end ------------ ------ */

return retval;
}
#endif

#if !defined(_impl_ulci_statistics__get_st_adr_reg_last_)
#define _impl_ulci_statistics__get_st_adr_reg_last_ 1
static CORBA_string
impl_ulci_statistics__get_st_adr_reg_last(impl_POA_ulci_statistics *servant,
CORBA_Environment *ev)
{
CORBA_string retval;
 /* ------   insert method code here   ------ */
   struct tm *t;
   char buff[64];
   
   g_mutex_lock(servant->ul_cont->mutex);
   t=localtime(&servant->ul_cont->ul_net->statistics->st_adr_req_last);
   strftime(buff,sizeof(buff),"%d.%m.%Y %H:%M:%S",t);
   retval=CORBA_string_dup(buff);   
   g_mutex_unlock(servant->ul_cont->mutex);
 /* ------ ---------- end ------------ ------ */

return retval;
}
#endif

#if !defined(_impl_ulci_settings__create_)
#define _impl_ulci_settings__create_ 1
static ulci_settings impl_ulci_settings__create(PortableServer_POA poa, CORBA_Environment *ev, ul_asd_context_t *ul_cont)
{
ulci_settings retval;
impl_POA_ulci_settings *newservant;
PortableServer_ObjectId *objid;

newservant = g_new0(impl_POA_ulci_settings, 1);
newservant->servant.vepv = &impl_ulci_settings_vepv;
newservant->poa = (PortableServer_POA) CORBA_Object_duplicate((CORBA_Object)poa, ev);
POA_ulci_settings__init((PortableServer_Servant)newservant, ev);
   /* Before servant is going to be activated all
    * private attributes must be initialized.  */
newservant->ul_cont=ul_cont;
   /* ------ init private attributes here ------ */
   /* ------ ---------- end ------------- ------ */

objid = PortableServer_POA_activate_object(poa, newservant, ev);
CORBA_free(objid);
retval = PortableServer_POA_servant_to_reference(poa, newservant, ev);

return retval;
}
#endif

#if !defined(_impl_ulci_settings__destroy_)
#define _impl_ulci_settings__destroy_ 1
static void
impl_ulci_settings__destroy(impl_POA_ulci_settings *servant, CORBA_Environment *ev)
{
    CORBA_Object_release ((CORBA_Object) servant->poa, ev);

    /* No further remote method calls are delegated to 
    * servant and you may free your private attributes. */
   /* ------ free private attributes here ------ */
   /* ------ ---------- end ------------- ------ */

POA_ulci_settings__fini((PortableServer_Servant)servant, ev);

g_free (servant);
}
#endif

#if !defined(_impl_ulci_settings__get_status_period_)
#define _impl_ulci_settings__get_status_period_ 1
static CORBA_unsigned_short
impl_ulci_settings__get_status_period(impl_POA_ulci_settings *servant,
CORBA_Environment *ev)
{
CORBA_unsigned_short retval;
 /* ------   insert method code here   ------ */
   g_mutex_lock(servant->ul_cont->mutex);
   retval=servant->ul_cont->ul_net->dy_state->period;
   g_mutex_unlock(servant->ul_cont->mutex);
 /* ------ ---------- end ------------ ------ */

return retval;
}
#endif

#if !defined(_impl_ulci_settings__set_status_period_)
#define _impl_ulci_settings__set_status_period_ 1
static void
impl_ulci_settings__set_status_period(impl_POA_ulci_settings *servant,
const CORBA_unsigned_short value,
CORBA_Environment *ev)
{
 /* ------   insert method code here   ------ */
   g_mutex_lock(servant->ul_cont->mutex);
   servant->ul_cont->ul_net->dy_state->period=value;
   g_mutex_unlock(servant->ul_cont->mutex);
 /* ------ ---------- end ------------ ------ */
}
#endif

#if !defined(_impl_ulci_settings__get_first_dy_adr_)
#define _impl_ulci_settings__get_first_dy_adr_ 1
static CORBA_unsigned_short
impl_ulci_settings__get_first_dy_adr(impl_POA_ulci_settings *servant,
CORBA_Environment *ev)
{
CORBA_unsigned_short retval;
 /* ------   insert method code here   ------ */
   g_mutex_lock(servant->ul_cont->mutex);
   retval=servant->ul_cont->ul_net->dy_state->first_dy_adr;
   g_mutex_unlock(servant->ul_cont->mutex);
 /* ------ ---------- end ------------ ------ */

return retval;
}
#endif

#if !defined(_impl_ulci_settings__set_first_dy_adr_)
#define _impl_ulci_settings__set_first_dy_adr_ 1
static void
impl_ulci_settings__set_first_dy_adr(impl_POA_ulci_settings *servant,
const CORBA_unsigned_short value,
CORBA_Environment *ev)
{
 /* ------   insert method code here   ------ */
   g_mutex_lock(servant->ul_cont->mutex);
   servant->ul_cont->ul_net->dy_state->first_dy_adr=value;
   g_mutex_unlock(servant->ul_cont->mutex);
 /* ------ ---------- end ------------ ------ */
}
#endif

#if !defined(_impl_ulci_settings__get_cycle_start_)
#define _impl_ulci_settings__get_cycle_start_ 1
static CORBA_unsigned_short
impl_ulci_settings__get_cycle_start(impl_POA_ulci_settings *servant,
CORBA_Environment *ev)
{
CORBA_unsigned_short retval;
 /* ------   insert method code here   ------ */
   g_mutex_lock(servant->ul_cont->mutex);
   retval=ul_dy_cycle_subfn;
   g_mutex_unlock(servant->ul_cont->mutex);
 /* ------ ---------- end ------------ ------ */

return retval;
}
#endif

#if !defined(_impl_ulci_settings__set_cycle_start_)
#define _impl_ulci_settings__set_cycle_start_ 1
static void
impl_ulci_settings__set_cycle_start(impl_POA_ulci_settings *servant,
const CORBA_unsigned_short value,
CORBA_Environment *ev)
{
 /* ------   insert method code here   ------ */
   g_mutex_lock(servant->ul_cont->mutex);
   ul_dy_cycle_subfn=value;
   g_mutex_unlock(servant->ul_cont->mutex);
 /* ------ ---------- end ------------ ------ */
}
#endif

#if !defined(_impl_ulci_settings_add_static_unit_)
#define _impl_ulci_settings_add_static_unit_ 1
static void
impl_ulci_settings_add_static_unit(impl_POA_ulci_settings *servant,
const CORBA_unsigned_short adr,
const CORBA_unsigned_short sn,
CORBA_Environment *ev)
{
 /* ------   insert method code here   ------ */
   g_mutex_lock(servant->ul_cont->mutex);
   ul_mod_static_add(servant->ul_cont->ul_net,adr,sn);
   g_mutex_unlock(servant->ul_cont->mutex);
 /* ------ ---------- end ------------ ------ */
}
#endif

#if !defined(_impl_ulci_settings_remove_static_unit_)
#define _impl_ulci_settings_remove_static_unit_ 1
static void
impl_ulci_settings_remove_static_unit(impl_POA_ulci_settings *servant,
const CORBA_unsigned_short sn,
CORBA_Environment *ev)
{
 /* ------   insert method code here   ------ */
   g_mutex_lock(servant->ul_cont->mutex);
   ul_mod_static_remove(servant->ul_cont->ul_net,sn);
   g_mutex_unlock(servant->ul_cont->mutex);
 /* ------ ---------- end ------------ ------ */
}
#endif

#if !defined(_impl_ulci_settings_get_units_)
#define _impl_ulci_settings_get_units_ 1
static ulci_units_t*
impl_ulci_settings_get_units(impl_POA_ulci_settings *servant,
CORBA_Environment *ev)
{
   ulci_units_t* retval;
   CORBA_long mindx=0;
   ulci_unit_t unit;

   /* ------   insert method code here   ------ */
   g_mutex_lock(servant->ul_cont->mutex);
   retval = ORBit_sequence_alloc (TC_CORBA_sequence_ulci_unit, 
                                  0);
   for(mindx=0;mindx<servant->ul_cont->ul_net->modules.count;mindx++) {
      ul_mod_info_t *mod=servant->ul_cont->ul_net->modules.items[mindx];
      unit.sn=mod->mod_sn;
      unit.adr=mod->mod_adr;
      unit.des=CORBA_string_dup(mod->mod_des?mod->mod_des:"");
      unit.flags=mod->flg;
      ORBit_sequence_append (retval, &unit); /* realloc */
   }
   retval->_release = TRUE;
   g_mutex_unlock(servant->ul_cont->mutex);
   /* ------ ---------- end ------------ ------ */
   return retval;   
}
#endif

#if !defined(_impl_ulci_settings_save_)
#define _impl_ulci_settings_save_ 1
static void
impl_ulci_settings_save(impl_POA_ulci_settings *servant,
CORBA_Environment *ev)
{
 /* ------   insert method code here   ------ */
    ul_asd_conf_save(NULL, servant->ul_cont);
 /* ------ ---------- end ------------ ------ */
}
#endif

